/* ////////////////////////////////////////////////////////////

  File Name: viewmenu.cpp
  Copyright (c) 2014 Soji Yamakawa.  All rights reserved.
  http://www.ysflight.com

//////////////////////////////////////////////////////////// */

#include <ysclass.h>
#include <ysport.h>
#include "fsgui3dapp.h"
#include "miscdlg.h"
#include <ysgl.h>
#include <fsguifiledialog.h>
#include "refbmp/refbmp.h"
#include "refbmp/refbmpdialog.h"



/* static */ void FsGui3DMainCanvas::View_DrawAxis(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	YsFlip(canvas.drawAxis);
	canvas.SetMenuCheck();
	canvas.SetNeedRedraw(YSTRUE);
}

/*static*/ void FsGui3DMainCanvas::View_OpenRefBmpDialog(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	Edit_ClearUIMode(appPtr,NULL,NULL);

	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	if(NULL==canvas.refBmpDlg)
	{
		canvas.refBmpDlg=PolyCreRefBmpDialog::Create();
	}
	canvas.refBmpDlg->Make(&canvas,canvas.refBmpStore);
	canvas.AddDialog(canvas.refBmpDlg);

	canvas.UIDrawCallBack3D=View_OpenRefBmpDialog_UIDrawCallBack3D;

	canvas.threeDInterface.SetCallBack(PolyCreRefBmpDialog::ThreeDInterfaceCallBack,canvas.refBmpDlg);

	canvas.ArrangeDialog();
	canvas.SetNeedRedraw(YSTRUE);
}

/*static*/ void FsGui3DMainCanvas::View_OpenRefBmpDialog_UIDrawCallBack3D(FsGui3DMainCanvas &canvas)
{
	const int sel=canvas.refBmpDlg->GetSelectedBitmapIndex();
	canvas.refBmpStore->DrawHighlight(sel);
}



void FsGui3DMainCanvas::View_DrawVertex(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	YsFlip(canvas.drawVertex);
	canvas.SetMenuCheck();
	canvas.SetNeedRedraw(YSTRUE);
}

/*static*/ void FsGui3DMainCanvas::View_DrawConstEdge(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	YsFlip(canvas.drawConstEdge);
	canvas.SetMenuCheck();
	canvas.SetNeedRedraw(YSTRUE);
}

void FsGui3DMainCanvas::View_DrawPolygonFill(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	YsFlip(canvas.drawPolygon);
	canvas.SetMenuCheck();
	canvas.SetNeedRedraw(YSTRUE);
}


void FsGui3DMainCanvas::View_DrawWireframe(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	YsFlip(canvas.drawPolygonEdge);
	canvas.SetMenuCheck();
	canvas.SetNeedRedraw(YSTRUE);
}

/*static*/ void FsGui3DMainCanvas::View_DrawBackFaceInDifferentColor(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	YsFlip(canvas.drawBackFaceInDifferentColor);
	canvas.SetMenuCheck();
	canvas.needRemakeDrawingBuffer|=NEED_REMAKE_DRAWING_POLYGON;
	canvas.SetNeedRedraw(YSTRUE);
}

void FsGui3DMainCanvas::View_DrawShrunkPolygon(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	YsFlip(canvas.drawShrunkPolygon);
	canvas.SetMenuCheck();
	canvas.SetNeedRedraw(YSTRUE);
}



void FsGui3DMainCanvas::View_FocusOn_SelectionCenterOfGravity(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas.slHd)
	{
		YsVec3 sum=YsOrigin();
		YSSIZE_T nSample=0;

		YsArray <YsShellVertexHandle> selVtHd;
		canvas.slHd->GetSelectedVertex(selVtHd);
		for(YSSIZE_T idx=0; idx<selVtHd.GetN(); ++idx)
		{
			YsVec3 vtPos;
			canvas.slHd->GetVertexPosition(vtPos,selVtHd[idx]);
			sum+=vtPos;
			++nSample;
		}

		YsArray <YsShellPolygonHandle> selPlHd;
		canvas.slHd->GetSelectedPolygon(selPlHd);
		for(YSSIZE_T idx=0; idx<selPlHd.GetN(); ++idx)
		{
			YsArray <YsVec3,4> plVtPos;
			canvas.slHd->GetVertexListOfPolygon(plVtPos,selPlHd[idx]);
			for(YSSIZE_T vtIdx=0; vtIdx<plVtPos.GetN(); ++vtIdx)
			{
				sum+=plVtPos[vtIdx];
				++nSample;
			}
		}

		YsArray <YsShellExt::ConstEdgeHandle> selCeHd;
		canvas.slHd->GetSelectedConstEdge(selCeHd);
		for(YSSIZE_T idx=0; idx<selCeHd.GetN(); ++idx)
		{
			YSBOOL isLoop;
			YsArray <YsShellVertexHandle,16> ceVtHd;
			canvas.slHd->GetConstEdge(ceVtHd,isLoop,selCeHd[idx]);
			for(YSSIZE_T vtIdx=0; vtIdx<ceVtHd.GetN(); ++vtIdx)
			{
				YsVec3 vtPos;
				canvas.slHd->GetVertexPosition(vtPos,ceVtHd[vtIdx]);
				sum+=vtPos;
				++nSample;
			}
		}

		YsArray <YsShellExt::FaceGroupHandle> selFgHd;
		canvas.slHd->GetSelectedFaceGroup(selFgHd);
		for(YSSIZE_T idx=0; idx<selFgHd.GetN(); ++idx)
		{
			YsArray <YsShellPolygonHandle,16> fgPlHd;
			canvas.slHd->GetFaceGroup(fgPlHd,selFgHd[idx]);
			for(YSSIZE_T plIdx=0; plIdx<fgPlHd.GetN(); ++plIdx)
			{
				YsArray <YsVec3,4> plVtPos;
				canvas.slHd->GetVertexListOfPolygon(plVtPos,fgPlHd[plIdx]);
				for(YSSIZE_T vtIdx=0; vtIdx<plVtPos.GetN(); ++vtIdx)
				{
					sum+=plVtPos[vtIdx];
					++nSample;
				}
			}
		}

		if(0<nSample)
		{
			const YsVec3 focusOn=sum/(double)nSample;
			canvas.drawEnv.SetViewTarget(focusOn);
			canvas.SetNeedRedraw(YSTRUE);
		}
	}
}


void FsGui3DMainCanvas::View_FocusOn_SelectionBoundingBoxCenter(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas.slHd)
	{
		YsBoundingBoxMaker3 mkBbx;
		YSSIZE_T nSample=0;

		YsArray <YsShellVertexHandle> selVtHd;
		canvas.slHd->GetSelectedVertex(selVtHd);
		for(YSSIZE_T idx=0; idx<selVtHd.GetN(); ++idx)
		{
			YsVec3 vtPos;
			canvas.slHd->GetVertexPosition(vtPos,selVtHd[idx]);
			mkBbx.Add(vtPos);
			++nSample;
		}

		YsArray <YsShellPolygonHandle> selPlHd;
		canvas.slHd->GetSelectedPolygon(selPlHd);
		for(YSSIZE_T idx=0; idx<selPlHd.GetN(); ++idx)
		{
			YsArray <YsVec3,4> plVtPos;
			canvas.slHd->GetVertexListOfPolygon(plVtPos,selPlHd[idx]);
			for(YSSIZE_T vtIdx=0; vtIdx<plVtPos.GetN(); ++vtIdx)
			{
				mkBbx.Add(plVtPos[vtIdx]);
				++nSample;
			}
		}

		YsArray <YsShellExt::ConstEdgeHandle> selCeHd;
		canvas.slHd->GetSelectedConstEdge(selCeHd);
		for(YSSIZE_T idx=0; idx<selCeHd.GetN(); ++idx)
		{
			YSBOOL isLoop;
			YsArray <YsShellVertexHandle,16> ceVtHd;
			canvas.slHd->GetConstEdge(ceVtHd,isLoop,selCeHd[idx]);
			for(YSSIZE_T vtIdx=0; vtIdx<ceVtHd.GetN(); ++vtIdx)
			{
				YsVec3 vtPos;
				canvas.slHd->GetVertexPosition(vtPos,ceVtHd[vtIdx]);
				mkBbx.Add(vtPos);
				++nSample;
			}
		}

		YsArray <YsShellExt::FaceGroupHandle> selFgHd;
		canvas.slHd->GetSelectedFaceGroup(selFgHd);
		for(YSSIZE_T idx=0; idx<selFgHd.GetN(); ++idx)
		{
			YsArray <YsShellPolygonHandle,16> fgPlHd;
			canvas.slHd->GetFaceGroup(fgPlHd,selFgHd[idx]);
			for(YSSIZE_T plIdx=0; plIdx<fgPlHd.GetN(); ++plIdx)
			{
				YsArray <YsVec3,4> plVtPos;
				canvas.slHd->GetVertexListOfPolygon(plVtPos,fgPlHd[plIdx]);
				for(YSSIZE_T vtIdx=0; vtIdx<plVtPos.GetN(); ++vtIdx)
				{
					mkBbx.Add(plVtPos[vtIdx]);
					++nSample;
				}
			}
		}

		if(0<nSample)
		{
			YsVec3 bbxCen;
			mkBbx.GetCenter(bbxCen);
			canvas.drawEnv.SetViewTarget(bbxCen);
			canvas.SetNeedRedraw(YSTRUE);
		}
	}
}


void FsGui3DMainCanvas::View_FocusOn_Vertex(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas.slHd)
	{
		Edit_ClearUIMode(appPtr,NULL,NULL);
		canvas.undoRedoRequireToClearUIMode=YSFALSE;
		canvas.deletionRequireToClearUIMode=YSFALSE;
		canvas.LButtonCallBack=View_FocusOn_Vertex_LButtonCallBack;
		canvas.SetNeedRedraw(YSTRUE);
	}
}

void FsGui3DMainCanvas::View_FocusOn_Vertex_RKey(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas.slHd)
	{
		int lb,mb,rb;
		int mx,my;
		FsGetMouseEvent(lb,mb,rb,mx,my);
		canvas.View_FocusOn_Vertex_Click(mx,my);
	}
}

YSRESULT FsGui3DMainCanvas::View_FocusOn_Vertex_LButtonCallBack(FsGui3DMainCanvas &canvas,YSBOOL,YSBOOL,YSBOOL,int mx,int my)
{
	return canvas.View_FocusOn_Vertex_Click(mx,my);
}

YSRESULT FsGui3DMainCanvas::View_FocusOn_Vertex_Click(int mx,int my)
{
	if(NULL!=slHd)
	{
		YsShellVertexHandle vtHd=PickedVtHd(mx,my,0,NULL);
		if(NULL!=vtHd)
		{
			YsVec3 vtPos;
			slHd->GetVertexPosition(vtPos,vtHd);
			drawEnv.SetViewTarget(vtPos);
			SetNeedRedraw(YSTRUE);
			return YSOK;
		}
	}
	return YSERR;
}



void FsGui3DMainCanvas::View_FocusOn_Polygon(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas.slHd)
	{
		Edit_ClearUIMode(appPtr,NULL,NULL);
		canvas.undoRedoRequireToClearUIMode=YSFALSE;
		canvas.deletionRequireToClearUIMode=YSFALSE;
		canvas.LButtonCallBack=View_FocusOn_Polygon_LButtonCallBack;
		canvas.SetNeedRedraw(YSTRUE);
	}
}

void FsGui3DMainCanvas::View_FocusOn_Polygon_ShiftRKey(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas.slHd)
	{
		int lb,mb,rb;
		int mx,my;
		FsGetMouseEvent(lb,mb,rb,mx,my);
		canvas.View_FocusOn_Polygon_Click(mx,my,YSFALSE);
	}
}

YSRESULT FsGui3DMainCanvas::View_FocusOn_Polygon_LButtonCallBack(FsGui3DMainCanvas &canvas,YSBOOL,YSBOOL,YSBOOL,int mx,int my)
{
	return canvas.View_FocusOn_Polygon_Click(mx,my,YSFALSE);
}

void FsGui3DMainCanvas::View_FocusOn_PolygonStraight(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas.slHd)
	{
		Edit_ClearUIMode(appPtr,NULL,NULL);
		canvas.undoRedoRequireToClearUIMode=YSFALSE;
		canvas.deletionRequireToClearUIMode=YSFALSE;
		canvas.LButtonCallBack=View_FocusOn_PolygonStraight_LButtonCallBack;
		canvas.SetNeedRedraw(YSTRUE);
	}
}

void FsGui3DMainCanvas::View_FocusOn_Polygon_ShiftCtrlRKey(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas.slHd)
	{
		int lb,mb,rb;
		int mx,my;
		FsGetMouseEvent(lb,mb,rb,mx,my);
		canvas.View_FocusOn_Polygon_Click(mx,my,YSTRUE);
	}
}

YSRESULT FsGui3DMainCanvas::View_FocusOn_PolygonStraight_LButtonCallBack(FsGui3DMainCanvas &canvas,YSBOOL,YSBOOL,YSBOOL,int mx,int my)
{
	return canvas.View_FocusOn_Polygon_Click(mx,my,YSTRUE);
}

YSRESULT FsGui3DMainCanvas::View_FocusOn_Polygon_Click(int mx,int my,YSBOOL alsoChangeOrientation)
{
	if(NULL!=slHd)
	{
		YsShellPolygonHandle plHd=PickedPlHd(mx,my,0,NULL);
		if(NULL!=plHd)
		{
			YsVec3 cen;
			slHd->GetCenterOfPolygon(cen,plHd);
			drawEnv.SetViewTarget(cen);

			if(YSTRUE==alsoChangeOrientation)
			{
				YsVec3 nom;
				slHd->GetNormalOfPolygon(nom,plHd);
				if(YsOrigin()==nom)
				{
					YsArray <YsVec3,4> plVtPos;
					slHd->GetVertexListOfPolygon(plVtPos,plHd);
					YsGetAverageNormalVector(nom,plVtPos.GetN(),plVtPos);
				}

				if(YsOrigin()!=nom)
				{
					YsVec3 curViewDir,newViewDir;
					drawEnv.GetViewDirection(curViewDir);
					if(0.0<=curViewDir*nom)
					{
						newViewDir=nom;
					}
					else
					{
						newViewDir=-nom;
					}
					drawEnv.SetViewDirection(newViewDir);
				}
			}

			SetNeedRedraw(YSTRUE);
			return YSOK;
		}
	}
	return YSERR;
}


void FsGui3DMainCanvas::View_ApplyViewPortToAllShell(void)
{
	if(NULL!=Slhd())
	{
		const YsVec3 viewPort[2]=
		{
			Slhd()->GetDrawingBuffer().viewPort[0],
			Slhd()->GetDrawingBuffer().viewPort[1]
		};
		YSBOOL enabled=Slhd()->GetDrawingBuffer().viewPortEnabled;

		auto allShlPtr=shlGrp.GetNodePointerAll();
		for(auto shlPtr : allShlPtr)
		{
			shlPtr->GetDrawingBuffer().viewPort[0]=viewPort[0];
			shlPtr->GetDrawingBuffer().viewPort[1]=viewPort[1];
			shlPtr->GetDrawingBuffer().viewPortEnabled=enabled;
		}

		if(YSTRUE==enabled)
		{
			needRemakeDrawingBuffer_for_OtherShell=NEED_REMAKE_DRAWING_ALL;
			SetNeedRedraw(YSTRUE);
		}
	}
}

/*static*/ void FsGui3DMainCanvas::View_UseSameViewPortForAllShell(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas.slHd)
	{
		YsFlip(canvas.drawApplyViewPortToAllShell);
		canvas.SetMenuCheck();
		if(YSTRUE==canvas.drawApplyViewPortToAllShell)
		{
			canvas.View_ApplyViewPortToAllShell();
		}
	}
}

void FsGui3DMainCanvas::View_EnableViewPort(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas.slHd)
	{
		YsFlip(canvas.slHd->GetDrawingBuffer().viewPortEnabled);

		if(YSTRUE==canvas.slHd->GetDrawingBuffer().viewPortEnabled &&
		   YSTRUE==canvas.drawApplyViewPortToAllShell)
		{
			canvas.View_ApplyViewPortToAllShell();
		}

		canvas.SetMenuCheck();
		canvas.needRemakeDrawingBuffer|=NEED_REMAKE_DRAWING_ALL;
		canvas.SetNeedRedraw(YSTRUE);
	}
}

void FsGui3DMainCanvas::View_ResetViewPort(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas.slHd)
	{
		canvas.shlGrp.GetBoundingBox(canvas.slHd->GetDrawingBuffer().viewPort);
		if(YSTRUE==canvas.slHd->GetDrawingBuffer().viewPortEnabled)
		{
			canvas.needRemakeDrawingBuffer|=NEED_REMAKE_DRAWING_ALL;
			canvas.SetNeedRedraw(YSTRUE);

			if(YSTRUE==canvas.drawApplyViewPortToAllShell)
			{
				canvas.View_ApplyViewPortToAllShell();
			}
		}
	}
}

void FsGui3DMainCanvas::View_MoveViewPort(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas.slHd)
	{
		Edit_ClearUIMode(appPtr,NULL,NULL);
		canvas.undoRedoRequireToClearUIMode=YSFALSE;
		canvas.deletionRequireToClearUIMode=YSFALSE;
		canvas.threeDInterface.BeginInputBox(canvas.slHd->GetDrawingBuffer().viewPort[0],canvas.slHd->GetDrawingBuffer().viewPort[1],YSTRUE,YSFALSE);
		canvas.threeDInterface.SetCallBack(View_MoveViewPort_BoxMoved,appPtr);
		canvas.SetNeedRedraw(YSTRUE);
	}
}

void FsGui3DMainCanvas::View_MoveViewPort_BoxMoved(void *appPtr,FsGui3DInterface &itfc)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas.slHd)
	{
		itfc.GetBox(canvas.slHd->GetDrawingBuffer().viewPort);

		if(YSTRUE==canvas.drawApplyViewPortToAllShell)
		{
			canvas.View_ApplyViewPortToAllShell();
		}

		if(YSTRUE==canvas.slHd->GetDrawingBuffer().viewPortEnabled)
		{
			canvas.needRemakeDrawingBuffer|=NEED_REMAKE_DRAWING_ALL;
			canvas.SetNeedRedraw(YSTRUE);
		}
	}
}

/*static*/ void FsGui3DMainCanvas::View_MoveViewPortToRotationCenter(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas.slHd)
	{
		const YsVec3 d=canvas.slHd->GetDrawingBuffer().viewPort[1]-canvas.slHd->GetDrawingBuffer().viewPort[0];

		auto viewTarget=canvas.drawEnv.GetViewTarget();
		canvas.slHd->GetDrawingBuffer().viewPort[0]=viewTarget-d/2.0;
		canvas.slHd->GetDrawingBuffer().viewPort[1]=viewTarget+d/2.0;

		if(YSTRUE==canvas.drawApplyViewPortToAllShell)
		{
			canvas.View_ApplyViewPortToAllShell();
		}

		if(YSTRUE==canvas.slHd->GetDrawingBuffer().viewPortEnabled)
		{
			canvas.needRemakeDrawingBuffer|=NEED_REMAKE_DRAWING_ALL;
			canvas.SetNeedRedraw(YSTRUE);
		}
	}
}

/*static*/ void FsGui3DMainCanvas::View_ExpandViewPort(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas.slHd)
	{
		const YsVec3 d=(canvas.slHd->GetDrawingBuffer().viewPort[1]-canvas.slHd->GetDrawingBuffer().viewPort[0])*1.1;
		const YsVec3 c=(canvas.slHd->GetDrawingBuffer().viewPort[1]+canvas.slHd->GetDrawingBuffer().viewPort[0])/2.0;

		canvas.slHd->GetDrawingBuffer().viewPort[0]=c-d/2.0;
		canvas.slHd->GetDrawingBuffer().viewPort[1]=c+d/2.0;;

		if(YSTRUE==canvas.drawApplyViewPortToAllShell)
		{
			canvas.View_ApplyViewPortToAllShell();
		}

		if(YSTRUE==canvas.slHd->GetDrawingBuffer().viewPortEnabled)
		{
			canvas.needRemakeDrawingBuffer|=NEED_REMAKE_DRAWING_ALL;
			canvas.SetNeedRedraw(YSTRUE);
		}
	}
}

/*static*/ void FsGui3DMainCanvas::View_ShrinkViewPort(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas.slHd)
	{
		const YsVec3 d=(canvas.slHd->GetDrawingBuffer().viewPort[1]-canvas.slHd->GetDrawingBuffer().viewPort[0])/1.1;
		const YsVec3 c=(canvas.slHd->GetDrawingBuffer().viewPort[1]+canvas.slHd->GetDrawingBuffer().viewPort[0])/2.0;

		canvas.slHd->GetDrawingBuffer().viewPort[0]=c-d/2.0;
		canvas.slHd->GetDrawingBuffer().viewPort[1]=c+d/2.0;;

		if(YSTRUE==canvas.drawApplyViewPortToAllShell)
		{
			canvas.View_ApplyViewPortToAllShell();
		}

		if(YSTRUE==canvas.slHd->GetDrawingBuffer().viewPortEnabled)
		{
			canvas.needRemakeDrawingBuffer|=NEED_REMAKE_DRAWING_ALL;
			canvas.SetNeedRedraw(YSTRUE);
		}
	}
}

/*static*/ void FsGui3DMainCanvas::View_ViewPortFromSelection(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	if(NULL!=canvas.slHd)
	{
		auto &shl=*canvas.slHd;

		YsShellExtEdit_DuplicateUtil dupUtil;

		auto selVtHd=shl.GetSelectedVertex();
		auto selPlHd=shl.GetSelectedPolygon();
		auto selFgHd=shl.GetSelectedFaceGroup();
		auto selCeHd=shl.GetSelectedConstEdge();
		// auto selVlHd=canvas.shl.GetSelectedVolume();

		dupUtil.CleanUp();
		dupUtil.SetShell(shl.Conv());
		dupUtil.AddVertex(selVtHd);
		dupUtil.AddPolygon(selPlHd);
		dupUtil.AddConstEdge(selCeHd);
		dupUtil.AddFaceGroup(selFgHd);
		// dupUtil.AddVolume(selVlHd);

		YsBoundingBoxMaker3 mkBbx;
		for(auto &vtx : dupUtil.vertexArray)
		{
			mkBbx.Add(vtx.pos);
		}

		YsVec3 bbx[2];
		mkBbx.Get(bbx);

		bbx[0].SubX(YsTolerance);
		bbx[0].SubY(YsTolerance);
		bbx[0].SubZ(YsTolerance);

		bbx[1].AddX(YsTolerance);
		bbx[1].AddY(YsTolerance);
		bbx[1].AddZ(YsTolerance);

		canvas.slHd->GetDrawingBuffer().viewPort[0]=bbx[0];
		canvas.slHd->GetDrawingBuffer().viewPort[1]=bbx[1];

		if(YSTRUE==canvas.drawApplyViewPortToAllShell)
		{
			canvas.View_ApplyViewPortToAllShell();
		}

		if(YSTRUE==canvas.slHd->GetDrawingBuffer().viewPortEnabled)
		{
			canvas.needRemakeDrawingBuffer|=NEED_REMAKE_DRAWING_ALL;
			canvas.SetNeedRedraw(YSTRUE);
		}
	}
}



/*static*/ void FsGui3DMainCanvas::View_LoadRefBmpConfig(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;

	YsString dataDir;
	dataDir.EncodeUTF8 <wchar_t> (canvas.GetDataDir());

	YsString def;
	def.MakeFullPathName(dataDir,"*.rfb");

	// YsString last(scn.GetLastOpenedFilename()),def;
	// if(last.Strlen()>0)
	// {
	// 	YsString pth,fil;
	// 	last.SeparatePathFile(pth,fil);
	// 	def.MakeFullPathName(pth,"*.fld");
	// }
	// else
	// {
	// 	def.MakeFullPathName(scnDir,"*.fld");
	// }

	canvas.fdlg->Initialize();
	canvas.fdlg->mode=FsGuiFileDialog::MODE_OPEN;
	canvas.fdlg->multiSelect=YSFALSE;
	canvas.fdlg->title.Set(L"Open Reference Bitmap Configuration");
	canvas.fdlg->fileExtensionArray.Append(L".rfb");
	canvas.fdlg->defaultFileName.SetUTF8String(def);
	canvas.fdlg->SetCloseModalCallBack(View_LoadRefBmpConfig_FileSelected);
	canvas.AttachModalDialog(canvas.fdlg);
}

/*static*/ void FsGui3DMainCanvas::View_LoadRefBmpConfig_FileSelected(FsGuiControlBase *appPtr,FsGuiDialog *,int returnValue)
{
printf("%s %d\n",__FUNCTION__,__LINE__);
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;

	if(YSOK==(YSRESULT)returnValue)
	{
		if(NULL!=canvas.refBmpStore)
		{
			canvas.refBmpStore->Load(canvas.fdlg->selectedFileArray[0]);
			canvas.SetNeedRedraw(YSTRUE);
		}
	}
}



/*static*/ void FsGui3DMainCanvas::View_SaveRefBmpConfig(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
printf("%s %d\n",__FUNCTION__,__LINE__);
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;

	YsString dataDir;
	dataDir.EncodeUTF8 <wchar_t> (canvas.GetDataDir());

	YsString def;
	def.MakeFullPathName(dataDir,"*.rfb");

	// YsString last(scn.GetLastOpenedFilename()),def;
	// if(last.Strlen()>0)
	// {
	// 	YsString pth,fil;
	// 	last.SeparatePathFile(pth,fil);
	// 	def.MakeFullPathName(pth,"*.fld");
	// }
	// else
	// {
	// 	def.MakeFullPathName(scnDir,"*.fld");
	// }

	canvas.fdlg->Initialize();
	canvas.fdlg->mode=FsGuiFileDialog::MODE_SAVE;
	canvas.fdlg->multiSelect=YSFALSE;
	canvas.fdlg->title.Set(L"Save Reference Bitmap Configuration");
	canvas.fdlg->fileExtensionArray.Append(L".rfb");
	canvas.fdlg->defaultFileName.SetUTF8String(def);
	canvas.fdlg->SetCloseModalCallBack(View_SaveRefBmpConfig_FileSelected);
	canvas.AttachModalDialog(canvas.fdlg);
}

/*static*/ void FsGui3DMainCanvas::View_SaveRefBmpConfig_FileSelected(FsGuiControlBase *appPtr,FsGuiDialog *,int returnCode)
{
	if((int)YSOK==returnCode)
	{
		FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;

		FILE *fp=YsFileIO::Fopen(canvas.fdlg->selectedFileArray[0],"rb");
		if(NULL!=fp)
		{
			fclose(fp);
			canvas.YesNoDialog(L"Confirmation",L"File Exists. Overwrite?",L"Yes",L"No",View_SaveRefBmpConfig_PassedOverwriteCheck);
			canvas.SetNeedRedraw(YSTRUE);
		}
		else
		{
			canvas.View_SaveRefBmpConfig_PassedOverwriteCheck(canvas.fdlg->selectedFileArray[0]);
		}
	}
}

/*static*/ void FsGui3DMainCanvas::View_SaveRefBmpConfig_PassedOverwriteCheck(FsGuiControlBase *appPtr,FsGuiDialog *,int returnCode)
{
	if(YSOK==(YSRESULT)returnCode)
	{
		FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
		canvas.View_SaveRefBmpConfig_PassedOverwriteCheck(canvas.fdlg->selectedFileArray[0]);
	}
}

void FsGui3DMainCanvas::View_SaveRefBmpConfig_PassedOverwriteCheck(const wchar_t fn[])
{
	if(NULL!=refBmpStore)
	{
		if(YSOK==refBmpStore->Save(fn))
		{
			MessageDialog(L"Saved",L"Saved Reference Bitmap Configuration");
		}
		else
		{
			MessageDialog(L"Error!",L"Failed to save Reference Bitmap Configuration");
		}
		SetNeedRedraw(YSTRUE);
	}
}

/*static*/ void FsGui3DMainCanvas::View_HighlightNonManifoldEdge(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	YsFlip(canvas.drawNonManifoldEdge);
	canvas.SetMenuCheck();
	canvas.SetNeedRedraw(YSTRUE);
}

/*static*/ void FsGui3DMainCanvas::View_ShowAllRefBmp(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	for(auto &refBmp : canvas.refBmpStore->refBmp)
	{
		refBmp.show=YSTRUE;
	}
	canvas.SetNeedRedraw(YSTRUE);
}

/*static*/ void FsGui3DMainCanvas::View_HideAllRefBmp(void *appPtr,FsGuiPopUpMenu *,FsGuiPopUpMenuItem *)
{
	FsGui3DMainCanvas &canvas=*(FsGui3DMainCanvas *)appPtr;
	for(auto &refBmp : canvas.refBmpStore->refBmp)
	{
		refBmp.show=YSFALSE;
	}
	canvas.SetNeedRedraw(YSTRUE);
}
