/* ////////////////////////////////////////////////////////////

  File Name: ysshellextedit_topologyutil.h
  Copyright (c) 2014 Soji Yamakawa.  All rights reserved.
  http://www.ysflight.com

//////////////////////////////////////////////////////////// */

#ifndef YSSHELLEXTEDIT_TOPOLOGYUTIL_IS_INCLUDED
#define YSSHELLEXTEDIT_TOPOLOGYUTIL_IS_INCLUDED
/* { */

#include <ysshellextedit.h>
#include "ysshellext_localop.h"

class YsShellExtEdit_TopologyUtil : private YsShell_LocalOperation
{
public:
	YsArray <YsShellPolygonHandle> modifiedPlHdArray;
	YsArray <YsShellExt::ConstEdgeHandle> modifiedCeHdArray;


	void CleanUp(void);

	YSRESULT InsertVertexOnEdge(YsShellExtEdit &shl,YsShellVertexHandle fromVtHd,YsShellVertexHandle toVtHd,int nVt,const YsShellVertexHandle vtHdArray[]);

	template <const int N>
	YSRESULT InsertVertexOnEdge(YsShellExtEdit &shl,YsShellVertexHandle fromVtHd,YsShellVertexHandle toVtHd,YsArray <YsShellVertexHandle,N> &vtHdArray);

	YSRESULT SplitPolygon(YsShellExtEdit &shl,YsShellPolygonHandle plHd,YsShellVertexHandle vtHd0,YsShellVertexHandle vtHd1);
	YSRESULT SplitPolygon(YsShellExtEdit &shl,YsShellPolygonHandle plHd,const YsShellVertexHandle vtHd[2]);
};

template <const int N>
YSRESULT YsShellExtEdit_TopologyUtil::InsertVertexOnEdge(YsShellExtEdit &shl,YsShellVertexHandle fromVtHd,YsShellVertexHandle toVtHd,YsArray <YsShellVertexHandle,N> &vtHdArray)
{
	return InsertVertexOnEdge(shl,fromVtHd,toVtHd,vtHdArray.GetN(),vtHdArray);
}

/* } */
#endif
