#include <ysclass.h>
#include "../ysfileinfo.h"
#include "../ysencoding.h"

#include <unistd.h>
#include <sys/stat.h>

extern "C" int YsMacOSXGetFileList(void *objPointer,const char dir[],int errCode,int okCode);

YSRESULT YsFileList::FindFileList(const char path[],const char prefix[],const char postfix[])
{
	YsWString wPath,wPrefix,wPostfix;
	YsSystemEncodingToUnicode(wPath,path);
	YsSystemEncodingToUnicode(wPrefix,prefix);
	YsSystemEncodingToUnicode(wPostfix,postfix);
	return FindFileList(wPath,wPrefix,wPostfix);
}

YSRESULT YsFileList::FindFileList(const wchar_t path[],const wchar_t prefix[],const wchar_t postfix[])
{
	this->path.Set(path);
	if(0<this->path.Strlen() && ('/'==this->path.LastChar() || '\\'==this->path.LastChar()))
	{
		this->path.BackSpace();
	}

	if(NULL!=prefix)
	{
		this->uPrefix.Set(prefix);
	}
	else
	{
		this->uPrefix.Set(NULL);  // Changed from L"" to NULL.  Workaround for GCC 64-bit bug
	}
	if(NULL!=postfix)
	{
		this->uPostfix.Set(postfix);
	}
	else
	{
		this->uPostfix.Set(NULL); // Changed from L"" to NULL.  Workaround for GCC 64-bit bug
	}
	this->uPrefix.Uncapitalize();
	this->uPostfix.Uncapitalize();

	Initialize();
	YsString utf8;
	utf8.EncodeUTF8 <wchar_t> (path);
	if((int)YSOK==YsMacOSXGetFileList(this,utf8,(int)YSERR,(int)YSOK))
	{
		return YSOK;
	}
	else
	{
		return YSERR;
	}
}

extern "C" void YsMacOSXGetFileListCallBack(void *objPointer,const char fn[],int isDirectory,unsigned long long fileSize)
{
	YsFileList *fileList=(YsFileList *)objPointer;
	unsigned long sizeHigh=(fileSize>>32)&0x7fffffff;
	unsigned long sizeLow=(fileSize&0xffffffff);
	YSBOOL isDir=(isDirectory==0 ? YSFALSE : YSTRUE);

	YsWString wFn;
	wFn.SetUTF8String(fn);
	fileList->TestAndAddFileInfo(wFn,isDir,sizeHigh,sizeLow);
}
